---
id: fast-animation.animate
title: Animate class
hide_title: true
---
<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[@microsoft/fast-animation](./fast-animation.md) &gt; [Animate](./fast-animation.animate.md)

## Animate class

Base animate type. This is extended by [AnimateTo](./fast-animation.animateto.md) and [AnimateFrom](./fast-animation.animatefrom.md)<!-- -->.

<b>Signature:</b>

```typescript
export default abstract class Animate 
```

## Constructors

|  Constructor | Modifiers | Description |
|  --- | --- | --- |
|  [(constructor)(element, options, effectTiming)](./fast-animation.animate._constructor_.md) |  | Constructs a new instance of the <code>Animate</code> class |

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [addKeyframes](./fast-animation.animate.addkeyframes.md) |  | (keyframes: Array&lt;Partial&lt;Keyframe&gt;&gt;) =&gt; void | adds a set of keyframes to set of animation keyframes the animation should execute |
|  [cancel](./fast-animation.animate.cancel.md) |  | () =&gt; void | cancels the animation |
|  [effectTiming](./fast-animation.animate.effecttiming.md) |  | EffectTiming | Stores animation timing functions |
|  [finish](./fast-animation.animate.finish.md) |  | () =&gt; void | finishes the animation |
|  [keyframeEffect](./fast-animation.animate.keyframeeffect.md) |  | KeyframeEffect | Returns the key frame effect object |
|  [keyframes](./fast-animation.animate.keyframes.md) |  | Keyframe\[\] | Returns the animation's keyframes |
|  [mode](./fast-animation.animate.mode.md) |  | AnimationMode | Tracks if the animation should animate toward an elements natural position or away from it |
|  [onCancel](./fast-animation.animate.oncancel.md) |  | () =&gt; void | Callback to call when the animation is canceled |
|  [onFinish](./fast-animation.animate.onfinish.md) |  | () =&gt; void |  |
|  [options](./fast-animation.animate.options.md) |  | AnimateConfig | Stores animation options |
|  [pause](./fast-animation.animate.pause.md) |  | () =&gt; void | pauses the animation |
|  [play](./fast-animation.animate.play.md) |  | () =&gt; void | plays the animation |
|  [reverse](./fast-animation.animate.reverse.md) |  | () =&gt; void | reverses an animation |
