---
id: fast-animation
title: fast-animation 
hide_title: false
---
<!-- Do not edit this file. It is automatically generated by API Documenter. -->



## Classes

|  Class | Description |
|  --- | --- |
|  [Animate](./fast-animation.animate.md) | Base animate type. This is extended by [AnimateTo](./fast-animation.animateto.md) and [AnimateFrom](./fast-animation.animatefrom.md)<!-- -->. |
|  [AnimateFrom](./fast-animation.animatefrom.md) | An animation from provided property values to the element's current values. Extends [Animate](./fast-animation.animate.md)<!-- -->. |
|  [AnimateGroup](./fast-animation.animategroup.md) | Groups [AnimateTo](./fast-animation.animateto.md) and [AnimateFrom](./fast-animation.animatefrom.md) instances, providing a single API to operate on all of them. |
|  [AnimateSequence](./fast-animation.animatesequence.md) | Animate a collection of [AnimateTo](./fast-animation.animateto.md) and [AnimateFrom](./fast-animation.animatefrom.md) in sequence. |
|  [AnimateTo](./fast-animation.animateto.md) | An animation to provided property values from the element's current values. Extends [Animate](./fast-animation.animate.md)<!-- -->. |
|  [ScrollTrigger](./fast-animation.scrolltrigger.md) | Utility for registering element/callback pairs where the callback will be called on scroll while the element is in view. |
|  [ViewEnterTrigger](./fast-animation.viewentertrigger.md) | Utility for registering element/callback pairs where the callback will be called when the element enters the view-port |
|  [ViewExitTrigger](./fast-animation.viewexittrigger.md) | Utility for registering element/callback pairs where the callback will be invoked when the element exits the view-port |

## Functions

|  Function | Description |
|  --- | --- |
|  [cubicBezier(name)](./fast-animation.cubicbezier.md) | Get a cubic bezier curve, formatted as a string, by name. |
|  [fadeIn(element, effectTiming)](./fast-animation.fadein.md) | Creates an animation to fade an element into view |
|  [fadeOut(element, effectTiming)](./fast-animation.fadeout.md) | Creates an animation to fade an element out of view |
