---
id: fast-components.directionalstylesheetbehavior
title: DirectionalStyleSheetBehavior class
hide_title: true
---
<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[@microsoft/fast-components](./fast-components.md) &gt; [DirectionalStyleSheetBehavior](./fast-components.directionalstylesheetbehavior.md)

## DirectionalStyleSheetBehavior class

Behavior to conditionally apply LTR and RTL stylesheets. To determine which to apply, the behavior will use the nearest DesignSystemProvider's 'direction' design system value.

<b>Signature:</b>

```typescript
export declare class DirectionalStyleSheetBehavior implements Behavior 
```

## Example


```ts
import { css } from "@microsoft/fast-element";
import { DirectionalStyleSheetBehavior } from "@microsoft/fast-foundation";

css`
 // ...
`.withBehaviors(new DirectionalStyleSheetBehavior(
  css`:host { content: "ltr"}`),
  css`:host { content: "rtl"}`),
)

```

## Constructors

|  Constructor | Modifiers | Description |
|  --- | --- | --- |
|  [(constructor)(ltr, rtl)](./fast-components.directionalstylesheetbehavior._constructor_.md) |  | Constructs a new instance of the <code>DirectionalStyleSheetBehavior</code> class |
