---
id: fast-element.attributedefinition
title: AttributeDefinition class
hide_title: true
---
<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[@microsoft/fast-element](./fast-element.md) &gt; [AttributeDefinition](./fast-element.attributedefinition.md)

## AttributeDefinition class

An implementation of [Accessor](./fast-element.accessor.md) that supports reactivity, change callbacks, attribute reflection, and type conversion for custom elements.

<b>Signature:</b>

```typescript
export declare class AttributeDefinition implements Accessor 
```

## Constructors

|  Constructor | Modifiers | Description |
|  --- | --- | --- |
|  [(constructor)(Owner, name, attribute, mode, converter)](./fast-element.attributedefinition._constructor_.md) |  | Creates an instance of AttributeDefinition. |

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [attribute](./fast-element.attributedefinition.attribute.md) |  | string | The name of the attribute in HTML. |
|  [converter](./fast-element.attributedefinition.converter.md) |  | [ValueConverter](./fast-element.valueconverter.md) | A [ValueConverter](./fast-element.valueconverter.md) that integrates with the property getter/setter to convert values to and from a DOM string. |
|  [mode](./fast-element.attributedefinition.mode.md) |  | [AttributeMode](./fast-element.attributemode.md) | The [AttributeMode](./fast-element.attributemode.md) that describes the behavior of this attribute. |
|  [name](./fast-element.attributedefinition.name.md) |  | string | The name of the property associated with the attribute. |
|  [Owner](./fast-element.attributedefinition.owner.md) |  | Function | The class constructor that owns this attribute. |

## Methods

|  Method | Modifiers | Description |
|  --- | --- | --- |
|  [getValue(source)](./fast-element.attributedefinition.getvalue.md) |  | Gets the value of the attribute/property on the source element. |
|  [setValue(source, newValue)](./fast-element.attributedefinition.setvalue.md) |  | Sets the value of the attribute/property on the source element. |
