---
id: fast-element.attributemode
title: AttributeMode type
hide_title: true
---
<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[@microsoft/fast-element](./fast-element.md) &gt; [AttributeMode](./fast-element.attributemode.md)

## AttributeMode type

The mode that specifies the runtime behavior of the attribute.

<b>Signature:</b>

```typescript
export declare type AttributeMode = "reflect" | "boolean" | "fromView";
```

## Remarks

By default, attributes run in `reflect` mode, propagating their property values to the DOM and DOM values to the property. The `boolean` mode also reflects values, but uses the HTML standard boolean attribute behavior, interpreting the presence of the attribute as `true` and the absence as `false`<!-- -->. The `fromView` behavior only updates the property value based on changes in the DOM, but does not reflect property changes back.
