---
id: fast-element.executioncontext
title: ExecutionContext class
hide_title: true
---
<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[@microsoft/fast-element](./fast-element.md) &gt; [ExecutionContext](./fast-element.executioncontext.md)

## ExecutionContext class

Provides additional contextual information available to behaviors and expressions.

<b>Signature:</b>

```typescript
export declare class ExecutionContext<TParent = any, TGrandparent = any> 
```

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [event](./fast-element.executioncontext.event.md) |  | Event | The current event within an event handler. |
|  [index](./fast-element.executioncontext.index.md) |  | number | The index of the current item within a repeat context. |
|  [isEven](./fast-element.executioncontext.iseven.md) |  | boolean | Indicates whether the current item within a repeat context has an even index. |
|  [isFirst](./fast-element.executioncontext.isfirst.md) |  | boolean | Indicates whether the current item within a repeat context is the first item in the collection. |
|  [isInMiddle](./fast-element.executioncontext.isinmiddle.md) |  | boolean | Indicates whether the current item within a repeat context is somewhere in the middle of the collection. |
|  [isLast](./fast-element.executioncontext.islast.md) |  | boolean | Indicates whether the current item within a repeat context is the last item in the collection. |
|  [isOdd](./fast-element.executioncontext.isodd.md) |  | boolean | Indicates whether the current item within a repeat context has an odd index. |
|  [length](./fast-element.executioncontext.length.md) |  | number | The length of the current collection within a repeat context. |
|  [parent](./fast-element.executioncontext.parent.md) |  | TParent | The parent data object within a repeat context. |
|  [parentContext](./fast-element.executioncontext.parentcontext.md) |  | [ExecutionContext](./fast-element.executioncontext.md)<!-- -->&lt;TGrandparent&gt; | The parent execution context when in nested context scenarios. |
