---
id: fast-element.html
title: html() function
hide_title: true
---
<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[@microsoft/fast-element](./fast-element.md) &gt; [html](./fast-element.html.md)

## html() function

Transforms a template literal string into a renderable ViewTemplate.

<b>Signature:</b>

```typescript
export declare function html<TSource = any, TParent = any>(strings: TemplateStringsArray, ...values: TemplateValue<TSource, TParent>[]): ViewTemplate<TSource, TParent>;
```

## Parameters

|  Parameter | Type | Description |
|  --- | --- | --- |
|  strings | TemplateStringsArray | The string fragments that are interpolated with the values. |
|  values | [TemplateValue](./fast-element.templatevalue.md)<!-- -->&lt;TSource, TParent&gt;\[\] | The values that are interpolated with the string fragments. |

<b>Returns:</b>

[ViewTemplate](./fast-element.viewtemplate.md)<!-- -->&lt;TSource, TParent&gt;

## Remarks

The html helper supports interpolation of strings, numbers, binding expressions, other template instances, and Directive instances.
