---
id: fast-element.syntheticview
title: SyntheticView interface
hide_title: true
---
<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[@microsoft/fast-element](./fast-element.md) &gt; [SyntheticView](./fast-element.syntheticview.md)

## SyntheticView interface

A view representing a range of DOM nodes which can be added/removed ad hoc.

<b>Signature:</b>

```typescript
export interface SyntheticView extends View 
```

## Properties

|  Property | Type | Description |
|  --- | --- | --- |
|  [firstChild](./fast-element.syntheticview.firstchild.md) | Node | The first DOM node in the range of nodes that make up the view. |
|  [lastChild](./fast-element.syntheticview.lastchild.md) | Node | The last DOM node in the range of nodes that make up the view. |

## Methods

|  Method | Description |
|  --- | --- |
|  [dispose()](./fast-element.syntheticview.dispose.md) | Removes the view and unbinds its behaviors, disposing of DOM nodes afterward. Once a view has been disposed, it cannot be inserted or bound again. |
|  [insertBefore(node)](./fast-element.syntheticview.insertbefore.md) | Inserts the view's DOM nodes before the referenced node. |
|  [remove()](./fast-element.syntheticview.remove.md) | Removes the view's DOM nodes. The nodes are not disposed and the view can later be re-inserted. |
