---
id: fast-foundation.accordionitem
title: AccordionItem class
hide_title: true
---
<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[@microsoft/fast-foundation](./fast-foundation.md) &gt; [AccordionItem](./fast-foundation.accordionitem.md)

## AccordionItem class

An individual item in an [Accordion](./fast-foundation.accordion.md)<!-- -->.


start - Content which can be provided between the heading and the icon


end - Content which can be provided between the start slot and icon


heading - Content which serves as the accordion item heading and text of the expand button


- The default slot for accordion item content


expanded-icon - The expanded icon


collapsed-icon - The collapsed icon


change - Fires a custom 'change' event when the button is invoked


heading - Wraps the button


button - The button which serves to invoke the item


heading-content - Wraps the slot for the heading content within the button


icon - The icon container


expanded-icon - The expanded icon slot


collapsed-icon - The collapsed icon


region - The wrapper for the accordion item content

<b>Signature:</b>

```typescript
export declare class AccordionItem extends FoundationElement 
```

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [expanded](./fast-foundation.accordionitem.expanded.md) |  | boolean | Expands or collapses the item. |
|  [headinglevel](./fast-foundation.accordionitem.headinglevel.md) |  | 1 \| 2 \| 3 \| 4 \| 5 \| 6 | Configures the [level](https://www.w3.org/TR/wai-aria-1.1/#aria-level) of the heading element. |
|  [id](./fast-foundation.accordionitem.id.md) |  | string | The item ID |
