---
id: fast-foundation.tabs
title: Tabs class
hide_title: true
---
<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[@microsoft/fast-foundation](./fast-foundation.md) &gt; [Tabs](./fast-foundation.tabs.md)

## Tabs class

A Tabs Custom HTML Element. Implements the [ARIA tablist](https://www.w3.org/TR/wai-aria-1.1/#tablist)<!-- -->.


start - Content which can be provided before the tablist element


end - Content which can be provided after the tablist element


tab - The slot for tabs


tabpanel - The slot for tabpanels


tablist - The element wrapping for the tabs


tab - The tab slot


activeIndicator - The visual indicator


tabpanel - The tabpanel slot


change - Fires a custom 'change' event when a tab is clicked or during keyboard navigation

<b>Signature:</b>

```typescript
export declare class Tabs extends FoundationElement 
```

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [activeid](./fast-foundation.tabs.activeid.md) |  | string | The id of the active tab |
|  [activeindicator](./fast-foundation.tabs.activeindicator.md) |  | boolean | Whether or not to show the active indicator |
|  [activetab](./fast-foundation.tabs.activetab.md) |  | HTMLElement | A reference to the active tab |
|  [orientation](./fast-foundation.tabs.orientation.md) |  | [TabsOrientation](./fast-foundation.tabsorientation.md) | The orientation |

## Methods

|  Method | Modifiers | Description |
|  --- | --- | --- |
|  [adjust(adjustment)](./fast-foundation.tabs.adjust.md) |  | The adjust method for FASTTabs |
